* apt-pkg/contrib/configuration.cc:
[ntk/apt.git] / cmdline / apt-key
1 #!/bin/sh
2
3 set -e
4 unset GREP_OPTIONS
5
6 # We don't use a secret keyring, of course, but gpg panics and
7 # implodes if there isn't one available
8 SECRETKEYRING="$(mktemp)"
9 trap "rm -f '${SECRETKEYRING}'" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
10 GPG_CMD="gpg --ignore-time-conflict --no-options --no-default-keyring --secret-keyring ${SECRETKEYRING}"
11
12 if [ "$(id -u)" -eq 0 ]; then
13 # we could use a tmpfile here too, but creation of this tends to be time-consuming
14 GPG_CMD="$GPG_CMD --trustdb-name /etc/apt/trustdb.gpg"
15 fi
16
17 GPG="$GPG_CMD"
18
19 MASTER_KEYRING=""
20 ARCHIVE_KEYRING_URI=""
21 #MASTER_KEYRING=/usr/share/keyrings/debian-master-keyring.gpg
22 #ARCHIVE_KEYRING_URI=http://ftp.debian.org/debian/debian-archive-keyring.gpg
23
24 ARCHIVE_KEYRING=/usr/share/keyrings/debian-archive-keyring.gpg
25 REMOVED_KEYS=/usr/share/keyrings/debian-archive-removed-keys.gpg
26
27 requires_root() {
28 if [ "$(id -u)" -ne 0 ]; then
29 echo >&1 "ERROR: This command can only be used by root."
30 exit 1
31 fi
32 }
33
34 add_keys_with_verify_against_master_keyring() {
35 ADD_KEYRING=$1
36 MASTER=$2
37
38 if [ ! -f "$ADD_KEYRING" ]; then
39 echo "ERROR: '$ADD_KEYRING' not found"
40 return
41 fi
42 if [ ! -f "$MASTER" ]; then
43 echo "ERROR: '$MASTER' not found"
44 return
45 fi
46
47 # when adding new keys, make sure that the archive-master-keyring
48 # is honored. so:
49 # all keys that are exported must have a valid signature
50 # from a key in the $distro-master-keyring
51 add_keys=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^pub | cut -d: -f5`
52 master_keys=`$GPG_CMD --keyring $MASTER --with-colons --list-keys | grep ^pub | cut -d: -f5`
53 for add_key in $add_keys; do
54 ADDED=0
55 for master_key in $master_keys; do
56 if $GPG_CMD --keyring $ADD_KEYRING --list-sigs --with-colons $add_key | grep ^sig | cut -d: -f5 | grep -q $master_key; then
57 $GPG_CMD --quiet --batch --keyring $ADD_KEYRING --export $add_key | $GPG --import
58 ADDED=1
59 fi
60 done
61 if [ $ADDED = 0 ]; then
62 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
63 fi
64 done
65 }
66
67 # update the current archive signing keyring from a network URI
68 # the archive-keyring keys needs to be signed with the master key
69 # (otherwise it does not make sense from a security POV)
70 net_update() {
71 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
72 echo >&2 "ERROR: Your distribution is not supported in net-update as no uri for the archive-keyring is set"
73 exit 1
74 fi
75 requires_root
76 # in theory we would need to depend on wget for this, but this feature
77 # isn't useable in debian anyway as we have no keyring uri nor a master key
78 if ! which wget >/dev/null 2>&1; then
79 echo >&2 "ERROR: an installed wget is required for a network-based update"
80 exit 1
81 fi
82 if [ ! -d /var/lib/apt/keyrings ]; then
83 mkdir -p /var/lib/apt/keyrings
84 fi
85 keyring=/var/lib/apt/keyrings/$(basename $ARCHIVE_KEYRING)
86 old_mtime=0
87 if [ -e $keyring ]; then
88 old_mtime=$(stat -c %Y $keyring)
89 fi
90 (cd /var/lib/apt/keyrings; wget -q -N $ARCHIVE_KEYRING_URI)
91 if [ ! -e $keyring ]; then
92 return
93 fi
94 new_mtime=$(stat -c %Y $keyring)
95 if [ $new_mtime -ne $old_mtime ]; then
96 echo "Checking for new archive signing keys now"
97 add_keys_with_verify_against_master_keyring $keyring $MASTER_KEYRING
98 fi
99 }
100
101 update() {
102 if [ ! -f $ARCHIVE_KEYRING ]; then
103 echo >&2 "ERROR: Can't find the archive-keyring"
104 echo >&2 "Is the debian-archive-keyring package installed?"
105 exit 1
106 fi
107 requires_root
108
109 # add new keys from the package;
110
111 # we do not use add_keys_with_verify_against_master_keyring here,
112 # because "update" is run on regular package updates. A
113 # attacker might as well replace the master-archive-keyring file
114 # in the package and add his own keys. so this check wouldn't
115 # add any security. we *need* this check on net-update though
116 $GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --import
117
118 if [ -r "$REMOVED_KEYS" ]; then
119 # remove no-longer supported/used keys
120 keys=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys | grep ^pub | cut -d: -f5`
121 for key in $keys; do
122 if $GPG --list-keys --with-colons | grep ^pub | cut -d: -f5 | grep -q $key; then
123 $GPG --quiet --batch --delete-key --yes ${key}
124 fi
125 done
126 else
127 echo "Warning: removed keys keyring $REMOVED_KEYS missing or not readable" >&2
128 fi
129 }
130
131
132 usage() {
133 echo "Usage: apt-key [--keyring file] [command] [arguments]"
134 echo
135 echo "Manage apt's list of trusted keys"
136 echo
137 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
138 echo " apt-key del <keyid> - remove the key <keyid>"
139 echo " apt-key export <keyid> - output the key <keyid>"
140 echo " apt-key exportall - output all trusted keys"
141 echo " apt-key update - update keys using the keyring package"
142 echo " apt-key net-update - update keys using the network"
143 echo " apt-key list - list keys"
144 echo " apt-key finger - list fingerprints"
145 echo " apt-key adv - pass advanced options to gpg (download key)"
146 echo
147 echo "If no specific keyring file is given the command applies to all keyring files."
148 }
149
150 # Determine on which keyring we want to work
151 if [ "$1" = "--keyring" ]; then
152 #echo "keyfile given"
153 shift
154 TRUSTEDFILE="$1"
155 if [ -r "$TRUSTEDFILE" ] || [ "$2" = 'add' ]; then
156 GPG="$GPG --keyring $TRUSTEDFILE --primary-keyring $TRUSTEDFILE"
157 else
158 echo >&2 "Error: The specified keyring »$TRUSTEDFILE« is missing or not readable"
159 exit 1
160 fi
161 shift
162 # otherwise use the default
163 else
164 #echo "generate list"
165 TRUSTEDFILE="/etc/apt/trusted.gpg"
166 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
167 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
168 if [ -r "$TRUSTEDFILE" ]; then
169 GPG="$GPG --keyring $TRUSTEDFILE"
170 fi
171 GPG="$GPG --primary-keyring $TRUSTEDFILE"
172 TRUSTEDPARTS="/etc/apt/trusted.gpg.d"
173 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
174 if [ -d "$TRUSTEDPARTS" ]; then
175 #echo "parts active"
176 for trusted in $(run-parts --list $TRUSTEDPARTS --regex '^.*\.gpg$'); do
177 #echo "part -> $trusted"
178 GPG="$GPG --keyring $trusted"
179 done
180 fi
181 fi
182 #echo "COMMAND: $GPG"
183
184 command="$1"
185 if [ -z "$command" ]; then
186 usage
187 exit 1
188 fi
189 shift
190
191 if [ "$command" != "help" ] && ! which gpg >/dev/null 2>&1; then
192 echo >&2 "Warning: gnupg does not seem to be installed."
193 echo >&2 "Warning: apt-key requires gnupg for most operations."
194 echo >&2
195 fi
196
197 case "$command" in
198 add)
199 requires_root
200 $GPG --quiet --batch --import "$1"
201 echo "OK"
202 ;;
203 del|rm|remove)
204 requires_root
205 $GPG --quiet --batch --delete-key --yes "$1"
206 echo "OK"
207 ;;
208 update)
209 update
210 ;;
211 net-update)
212 net_update
213 ;;
214 list)
215 $GPG --batch --list-keys
216 ;;
217 finger*)
218 $GPG --batch --fingerprint
219 ;;
220 export)
221 $GPG --armor --export "$1"
222 ;;
223 exportall)
224 $GPG --armor --export
225 ;;
226 adv*)
227 echo "Executing: $GPG $*"
228 $GPG $*
229 ;;
230 help)
231 usage
232 ;;
233 *)
234 usage
235 exit 1
236 ;;
237 esac